---
# Cop supports --autocorrect.
Lint/RedundantCopDisableDirective:
  # Offense count: 429
  # Temporarily disabled due to too many offenses
  Enabled: false
  Exclude:
    - 'app/controllers/concerns/enforces_two_factor_authentication.rb'
    - 'app/controllers/concerns/issuable_actions.rb'
    - 'app/controllers/concerns/web_hooks/hook_log_actions.rb'
    - 'app/controllers/groups/autocomplete_sources_controller.rb'
    - 'app/controllers/groups/labels_controller.rb'
    - 'app/controllers/projects/merge_requests/diffs_controller.rb'
    - 'app/controllers/projects/merge_requests_controller.rb'
    - 'app/finders/autocomplete/acts_as_taggable_on/tags_finder.rb'
    - 'app/finders/autocomplete/move_to_project_finder.rb'
    - 'app/finders/autocomplete/routes_finder.rb'
    - 'app/finders/ci/daily_build_group_report_results_finder.rb'
    - 'app/finders/ci/runner_jobs_finder.rb'
    - 'app/finders/groups_finder.rb'
    - 'app/finders/users_finder.rb'
    - 'app/graphql/gitlab_schema.rb'
    - 'app/graphql/resolvers/concerns/caching_array_resolver.rb'
    - 'app/graphql/resolvers/project_milestones_resolver.rb'
    - 'app/graphql/types/base_enum.rb'
    - 'app/graphql/types/ci/runner_web_url_edge.rb'
    - 'app/graphql/types/commit_signatures/verification_status_enum.rb'
    - 'app/graphql/types/packages/helm/dependency_type.rb'
    - 'app/graphql/types/projects/service_type_enum.rb'
    - 'app/helpers/diff_helper.rb'
    - 'app/helpers/lazy_image_tag_helper.rb'
    - 'app/helpers/search_helper.rb'
    - 'app/models/clusters/cluster.rb'
    - 'app/models/concerns/cascading_namespace_setting_attribute.rb'
    - 'app/models/concerns/from_except.rb'
    - 'app/models/concerns/from_intersect.rb'
    - 'app/models/concerns/from_union.rb'
    - 'app/models/concerns/redis_cacheable.rb'
    - 'app/models/user.rb'
    - 'app/presenters/dev_ops_report/metric_presenter.rb'
    - 'app/presenters/packages/nuget/search_results_presenter.rb'
    - 'app/serializers/diffs_entity.rb'
    - 'app/serializers/fork_namespace_entity.rb'
    - 'app/services/ci/job_artifacts/destroy_batch_service.rb'
    - 'app/services/ci/register_job_service.rb'
    - 'app/services/ci/retry_job_service.rb'
    - 'app/services/ci/runners/bulk_delete_runners_service.rb'
    - 'app/services/database/consistency_check_service.rb'
    - 'app/services/groups/import_export/import_service.rb'
    - 'app/services/issues/export_csv_service.rb'
    - 'app/services/labels/transfer_service.rb'
    - 'app/services/members/create_service.rb'
    - 'app/services/members/projects/creator_service.rb'
    - 'app/services/members/standard_member_builder.rb'
    - 'app/services/projects/auto_devops/disable_service.rb'
    - 'app/services/projects/open_issues_count_service.rb'
    - 'app/services/releases/create_service.rb'
    - 'app/services/releases/update_service.rb'
    - 'app/services/spam/spam_action_service.rb'
    - 'app/services/web_hook_service.rb'
    - 'app/uploaders/object_storage/cdn/google_ip_cache.rb'
    - 'app/workers/authorized_project_update/user_refresh_over_user_range_worker.rb'
    - 'app/workers/build_hooks_worker.rb'
    - 'app/workers/bulk_imports/entity_worker.rb'
    - 'app/workers/ci/track_failed_build_worker.rb'
    - 'app/workers/container_registry/migration/enqueuer_worker.rb'
    - 'app/workers/create_note_diff_file_worker.rb'
    - 'app/workers/database/batched_background_migration/execution_worker.rb'
    - 'app/workers/import_issues_csv_worker.rb'
    - 'app/workers/incident_management/process_alert_worker_v2.rb'
    - 'app/workers/merge_worker.rb'
    - 'app/workers/new_merge_request_worker.rb'
    - 'app/workers/remove_unaccepted_member_invites_worker.rb'
    - 'app/workers/run_pipeline_schedule_worker.rb'
    - 'config/initializers/grape_validators.rb'
    - 'config/initializers/warden.rb'
    - 'config/initializers/wikicloth_redos_patch.rb'
    - 'config/initializers/wikicloth_ruby_3_patch.rb'
    - 'config/routes/api.rb'
    - 'db/migrate/20220316022505_create_namespace_details.rb'
    - 'db/migrate/20220421141342_add_allowed_plans_to_ci_runners.rb'
    - 'db/migrate/20220531024905_add_operations_access_levels_to_project_feature.rb'
    - 'db/post_migrate/20220328100456_schedule20220328_reset_duplicate_ci_runners_token_encrypted_values_on_projects.rb'
    - 'db/post_migrate/20220328100457_schedule20220328_reset_duplicate_ci_runners_token_values_on_projects.rb'
    - 'db/post_migrate/20220720090354_remove_pending_builds_covering_index_from_ci_builds.rb'
    - 'db/post_migrate/20220902204048_move_security_findings_table_to_gitlab_partitions_dynamic_schema.rb'
    - 'db/post_migrate/20221102231131_remove_temp_index_for_user_details_fields.rb'
    - 'db/post_migrate/20230104103748_remove_new_amount_used_column.rb'
    - 'db/post_migrate/20230105180002_remove_new_amount_used_column_on_ci_namespace_monthly_usages.rb'
    - 'ee/app/controllers/ee/admin/application_settings_controller.rb'
    - 'ee/app/controllers/ee/groups/group_members_controller.rb'
    - 'ee/app/controllers/ee/projects/settings/ci_cd_controller.rb'
    - 'ee/app/controllers/groups/todos_controller.rb'
    - 'ee/app/finders/epics/with_issues_finder.rb'
    - 'ee/app/finders/geo/file_registry_finder.rb'
    - 'ee/app/finders/geo/project_registry_finder.rb'
    - 'ee/app/finders/geo/registry_finder.rb'
    - 'ee/app/finders/status_page/incident_comments_finder.rb'
    - 'ee/app/finders/status_page/incidents_finder.rb'
    - 'ee/app/graphql/types/ci/minutes/namespace_monthly_usage_type.rb'
    - 'ee/app/graphql/types/incident_management/oncall_rotation_active_period_input_type.rb'
    - 'ee/app/graphql/types/scan_type.rb'
    - 'ee/app/graphql/types/vulnerability_request_type.rb'
    - 'ee/app/helpers/ee/boards_helper.rb'
    - 'ee/app/helpers/projects/on_demand_scans_helper.rb'
    - 'ee/app/models/approver.rb'
    - 'ee/app/models/approver_group.rb'
    - 'ee/app/models/dast/branch.rb'
    - 'ee/app/models/ee/epic.rb'
    - 'ee/app/models/ee/group.rb'
    - 'ee/app/models/ee/merge_request.rb'
    - 'ee/app/models/ee/project.rb'
    - 'ee/app/models/ee/user.rb'
    - 'ee/app/models/ee/vulnerability.rb'
    - 'ee/app/models/geo/event_log.rb'
    - 'ee/app/models/geo_node.rb'
    - 'ee/app/models/protected_environments/approval_rules/summarizable.rb'
    - 'ee/app/models/requirements_management/requirement.rb'
    - 'ee/app/services/analytics/cycle_analytics/consistency_check_service.rb'
    - 'ee/app/services/analytics/cycle_analytics/data_loader_service.rb'
    - 'ee/app/services/ee/boards/issues/list_service.rb'
    - 'ee/app/services/ee/ci/queue/build_queue_service.rb'
    - 'ee/app/services/ee/search_service.rb'
    - 'ee/app/services/security/token_revocation_service.rb'
    - 'ee/app/workers/ee/issuable_export_csv_worker.rb'
    - 'ee/app/workers/ee/namespaces/in_product_marketing_emails_worker.rb'
    - 'ee/app/workers/geo/design_repository_shard_sync_worker.rb'
    - 'ee/app/workers/geo/repository_shard_sync_worker.rb'
    - 'ee/app/workers/geo/repository_verification/secondary/shard_worker.rb'
    - 'ee/app/workers/scan_security_report_secrets_worker.rb'
    - 'ee/app/workers/security/orchestration_policy_rule_schedule_worker.rb'
    - 'ee/db/geo/migrate/20210504143244_add_verification_to_merge_request_diff_registry.rb'
    - 'ee/lib/analytics/merge_request_metrics_calculator.rb'
    - 'ee/lib/api/audit_events.rb'
    - 'ee/lib/api/dora/metrics.rb'
    - 'ee/lib/ee/api/entities/analytics/code_review/merge_request.rb'
    - 'ee/lib/ee/gitlab/background_migration/backfill_epic_cache_counts.rb'
    - 'ee/lib/ee/gitlab/background_migration/backfill_project_statistics_storage_size_without_uploads_size.rb'
    - 'ee/lib/ee/gitlab/background_migration/fix_security_scan_statuses.rb'
    - 'ee/lib/ee/gitlab/background_migration/migrate_shared_vulnerability_scanners.rb'
    - 'ee/lib/ee/gitlab/background_migration/migrate_vulnerabilities_feedback_to_vulnerabilities_state_transition.rb'
    - 'ee/lib/ee/gitlab/background_migration/purge_stale_security_scans.rb'
    - 'ee/lib/ee/gitlab/usage_data.rb'
    - 'ee/lib/gitlab/analytics/type_of_work/tasks_by_type.rb'
    - 'ee/lib/gitlab/elastic/bool_expr.rb'
    - 'ee/lib/gitlab/spdx/license.rb'
    - 'ee/lib/gitlab/status_page/storage/object.rb'
    - 'ee/spec/controllers/concerns/gitlab_subscriptions/seat_count_alert_spec.rb'
    - 'ee/spec/controllers/concerns/routable_actions_spec.rb'
    - 'ee/spec/elastic/migrate/20221026082700_backfill_users_spec.rb'
    - 'ee/spec/features/boards/user_visits_board_spec.rb'
    - 'ee/spec/features/groups/settings/domain_verification_spec.rb'
    - 'ee/spec/helpers/ee/releases_helper_spec.rb'
    - 'ee/spec/lib/ee/gitlab/background_migration/backfill_project_statistics_container_repository_size_spec.rb'
    - 'ee/spec/lib/ee/gitlab/background_migration/backfill_project_statistics_storage_size_without_uploads_size_spec.rb'
    - 'ee/spec/lib/ee/gitlab/issuable_metadata_spec.rb'
    - 'ee/spec/lib/elastic/latest/project_instance_proxy_spec.rb'
    - 'ee/spec/lib/gitlab/geo/log_helpers_spec.rb'
    - 'ee/spec/lib/gitlab/usage/metrics/instrumentations/count_user_merge_requests_for_projects_with_applied_scan_result_policies_metric_spec.rb'
    - 'ee/spec/lib/gitlab/usage/metrics/instrumentations/protected_environment_approval_rules_required_approvals_average_metric_spec.rb'
    - 'ee/spec/requests/api/conan_project_packages_spec.rb'
    - 'ee/spec/requests/api/graphql/mutations/boards/epic_boards/epic_move_list_spec.rb'
    - 'ee/spec/services/security/merge_reports_service_spec.rb'
    - 'ee/spec/support/shared_examples/models/elasticsearch_indexed_container_shared_examples.rb'
    - 'ee/spec/support/shared_examples/models/geo_verifiable_registry_shared_examples.rb'
    - 'lib/api/api.rb'
    - 'lib/api/ci/variables.rb'
    - 'lib/api/entities/issuable_time_stats.rb'
    - 'lib/api/helpers.rb'
    - 'lib/api/issue_links.rb'
    - 'lib/backup/manager.rb'
    - 'lib/bulk_imports/common/transformers/user_reference_transformer.rb'
    - 'lib/bulk_imports/pipeline/runner.rb'
    - 'lib/container_registry/tag.rb'
    - 'lib/event_filter.rb'
    - 'lib/feature.rb'
    - 'lib/gitlab/analytics/cycle_analytics/aggregated/base_query_builder.rb'
    - 'lib/gitlab/analytics/cycle_analytics/base_query_builder.rb'
    - 'lib/gitlab/analytics/cycle_analytics/records_fetcher.rb'
    - 'lib/gitlab/application_context.rb'
    - 'lib/gitlab/background_migration/backfill_issue_search_data.rb'
    - 'lib/gitlab/background_migration/backfill_project_statistics_container_repository_size.rb'
    - 'lib/gitlab/background_migration/backfill_project_statistics_storage_size_without_uploads_size.rb'
    - 'lib/gitlab/background_migration/batching_strategies/loose_index_scan_batching_strategy.rb'
    - 'lib/gitlab/background_migration/fix_incoherent_packages_size_on_project_statistics.rb'
    - 'lib/gitlab/background_migration/migrate_personal_namespace_project_maintainer_to_owner.rb'
    - 'lib/gitlab/background_migration/re_expire_o_auth_tokens.rb'
    - 'lib/gitlab/background_migration/remove_occurrence_pipelines_and_duplicate_vulnerabilities_findings.rb'
    - 'lib/gitlab/background_migration/update_jira_tracker_data_deployment_type_based_on_url.rb'
    - 'lib/gitlab/bitbucket_import/importer.rb'
    - 'lib/gitlab/buffered_io.rb'
    - 'lib/gitlab/cache/request_cache.rb'
    - 'lib/gitlab/ci/build/artifacts/metadata/entry.rb'
    - 'lib/gitlab/ci/pipeline/chain/command.rb'
    - 'lib/gitlab/ci/pipeline/duration.rb'
    - 'lib/gitlab/ci/reports/accessibility_reports.rb'
    - 'lib/gitlab/ci/reports/test_report.rb'
    - 'lib/gitlab/ci/reports/test_reports_comparer.rb'
    - 'lib/gitlab/ci/reports/test_suite.rb'
    - 'lib/gitlab/ci/reports/test_suite_summary.rb'
    - 'lib/gitlab/cleanup/personal_access_tokens.rb'
    - 'lib/gitlab/composer/cache.rb'
    - 'lib/gitlab/database/consistency_checker.rb'
    - 'lib/gitlab/database/migration.rb'
    - 'lib/gitlab/database/migrations/observation.rb'
    - 'lib/gitlab/database/migrations/observers/query_log.rb'
    - 'lib/gitlab/database/rename_reserved_paths_migration/v1/rename_namespaces.rb'
    - 'lib/gitlab/diff/file.rb'
    - 'lib/gitlab/diff/file_collection/paginated_diffs.rb'
    - 'lib/gitlab/diff/pair_selector.rb'
    - 'lib/gitlab/diff/parser.rb'
    - 'lib/gitlab/encrypted_incoming_email_command.rb'
    - 'lib/gitlab/encrypted_ldap_command.rb'
    - 'lib/gitlab/encrypted_service_desk_email_command.rb'
    - 'lib/gitlab/encrypted_smtp_command.rb'
    - 'lib/gitlab/git/commit.rb'
    - 'lib/gitlab/git/patches/collection.rb'
    - 'lib/gitlab/github_import/markdown_text.rb'
    - 'lib/gitlab/github_import/user_finder.rb'
    - 'lib/gitlab/graphql/pagination/keyset/connection.rb'
    - 'lib/gitlab/health_checks/metric.rb'
    - 'lib/gitlab/health_checks/probes/status.rb'
    - 'lib/gitlab/health_checks/result.rb'
    - 'lib/gitlab/legacy_github_import/user_formatter.rb'
    - 'lib/gitlab/middleware/release_env.rb'
    - 'lib/gitlab/object_hierarchy.rb'
    - 'lib/gitlab/pagination/keyset/pager.rb'
    - 'lib/gitlab/performance_bar/redis_adapter_when_peek_enabled.rb'
    - 'lib/gitlab/profiler.rb'
    - 'lib/gitlab/project_search_results.rb'
    - 'lib/gitlab/redis/hll.rb'
    - 'lib/gitlab/search/sort_options.rb'
    - 'lib/gitlab/seeders/ci/runner/runner_fleet_seeder.rb'
    - 'lib/gitlab/sidekiq_middleware/duplicate_jobs/duplicate_job.rb'
    - 'lib/gitlab/slash_commands/issue_search.rb'
    - 'lib/gitlab/slash_commands/result.rb'
    - 'lib/gitlab/usage/metrics/instrumentations/count_imported_projects_metric.rb'
    - 'lib/gitlab/usage_data.rb'
    - 'lib/gitlab/usage_data_queries.rb'
    - 'lib/gitlab/utils/usage_data.rb'
    - 'lib/gitlab/x509/signature.rb'
    - 'lib/tasks/gitlab/cleanup.rake'
    - 'qa/qa/specs/features/ee/browser_ui/10_govern/create_merge_request_with_secure_spec.rb'
    - 'qa/qa/specs/features/ee/browser_ui/10_govern/security_reports_spec.rb'
    - 'qa/qa/specs/features/ee/browser_ui/10_govern/vulnerability_management_spec.rb'
    - 'rubocop/cop/static_translation_definition.rb'
    - 'scripts/security-harness'
    - 'sidekiq_cluster/cli.rb'
    - 'sidekiq_cluster/sidekiq_cluster.rb'
    - 'spec/components/previews/pajamas/banner_component_preview.rb'
    - 'spec/controllers/concerns/preferred_language_switcher_spec.rb'
    - 'spec/controllers/profiles/two_factor_auths_controller_spec.rb'
    - 'spec/finders/personal_access_tokens_finder_spec.rb'
    - 'spec/frontend/fixtures/merge_requests.rb'
    - 'spec/graphql/mutations/clusters/agent_tokens/create_spec.rb'
    - 'spec/graphql/mutations/clusters/agents/create_spec.rb'
    - 'spec/graphql/mutations/clusters/agents/delete_spec.rb'
    - 'spec/graphql/mutations/commits/create_spec.rb'
    - 'spec/graphql/resolvers/base_resolver_spec.rb'
    - 'spec/helpers/releases_helper_spec.rb'
    - 'spec/lib/gitlab/avatar_cache_spec.rb'
    - 'spec/lib/gitlab/background_migration/backfill_cluster_agents_has_vulnerabilities_spec.rb'
    - 'spec/lib/gitlab/background_migration/backfill_project_member_namespace_id_spec.rb'
    - 'spec/lib/gitlab/background_migration/backfill_vulnerability_reads_cluster_agent_spec.rb'
    - 'spec/lib/gitlab/background_migration/batching_strategies/backfill_project_statistics_with_container_registry_size_batching_strategy_spec.rb'
    - 'spec/lib/gitlab/background_migration/batching_strategies/remove_backfilled_job_artifacts_expire_at_batching_strategy_spec.rb'
    - 'spec/lib/gitlab/background_migration/reset_duplicate_ci_runners_token_encrypted_values_on_projects_spec.rb'
    - 'spec/lib/gitlab/background_migration/reset_duplicate_ci_runners_token_values_on_projects_spec.rb'
    - 'spec/lib/gitlab/ci/reports/security/scanner_spec.rb'
    - 'spec/lib/gitlab/database/load_balancing/transaction_leaking_spec.rb'
    - 'spec/lib/gitlab/database/migration_helpers/restrict_gitlab_schema_spec.rb'
    - 'spec/lib/gitlab/doorkeeper_secret_storing/secret/pbkdf2_sha512_spec.rb'
    - 'spec/lib/gitlab/doorkeeper_secret_storing/token/pbkdf2_sha512_spec.rb'
    - 'spec/lib/gitlab/gfm/uploads_rewriter_spec.rb'
    - 'spec/lib/gitlab/git/tree_spec.rb'
    - 'spec/lib/gitlab/import_export/project/relation_saver_spec.rb'
    - 'spec/lib/gitlab/memory/watchdog/configurator_spec.rb'
    - 'spec/lib/gitlab/merge_requests/message_generator_spec.rb'
    - 'spec/lib/gitlab/pagination/keyset/iterator_spec.rb'
    - 'spec/lib/gitlab/quick_actions/dsl_spec.rb'
    - 'spec/lib/gitlab/rack_attack/request_spec.rb'
    - 'spec/lib/gitlab/redis/multi_store_spec.rb'
    - 'spec/lib/gitlab/shard_health_cache_spec.rb'
    - 'spec/lib/gitlab/sidekiq_middleware/server_metrics_spec.rb'
    - 'spec/lib/gitlab/sidekiq_middleware/size_limiter/server_spec.rb'
    - 'spec/metrics_server/metrics_server_spec.rb'
    - 'spec/migrations/20220725150127_update_jira_tracker_data_deployment_type_based_on_url_spec.rb'
    - 'spec/migrations/add_namespaces_emails_enabled_column_data_spec.rb'
    - 'spec/migrations/add_projects_emails_enabled_column_data_spec.rb'
    - 'spec/models/ci/build_trace_chunk_spec.rb'
    - 'spec/models/ci/pipeline_spec.rb'
    - 'spec/models/concerns/encrypted_user_password_spec.rb'
    - 'spec/models/concerns/triggerable_hooks_spec.rb'
    - 'spec/models/namespace/package_setting_spec.rb'
    - 'spec/models/namespace_spec.rb'
    - 'spec/models/project_feature_spec.rb'
    - 'spec/models/project_spec.rb'
    - 'spec/presenters/packages/nuget/search_results_presenter_spec.rb'
    - 'spec/presenters/packages/pypi/simple_index_presenter_spec.rb'
    - 'spec/presenters/packages/pypi/simple_package_versions_presenter_spec.rb'
    - 'spec/requests/api/alert_management_alerts_spec.rb'
    - 'spec/requests/api/graphql/ci/config_spec.rb'
    - 'spec/rubocop/cop/ruby_interpolation_in_translation_spec.rb'
    - 'spec/services/alert_management/metric_images/upload_service_spec.rb'
    - 'spec/services/boards/lists/list_service_spec.rb'
    - 'spec/services/projects/update_statistics_service_spec.rb'
    - 'spec/services/spam/spam_verdict_service_spec.rb'
    - 'spec/services/topics/merge_service_spec.rb'
    - 'spec/support/forgery_protection.rb'
    - 'spec/support/helpers/database/multiple_databases_helpers.rb'
    - 'spec/support/helpers/snowplow_helpers.rb'
    - 'spec/support/helpers/wait_for_requests.rb'
    - 'spec/support/shared_examples/lib/gitlab/local_and_remote_storage_migration_shared_examples.rb'
    - 'spec/support/shared_examples/models/boards/listable_shared_examples.rb'
    - 'spec/support/shared_examples/models/concerns/incident_management/escalatable_shared_examples.rb'
    - 'spec/support/shared_examples/models/packages/debian/distribution_key_shared_examples.rb'
    - 'spec/support/shared_examples/requests/api/rubygems_packages_shared_examples.rb'
    - 'spec/uploaders/packages/composer/cache_uploader_spec.rb'
    - 'tooling/danger/analytics_instrumentation.rb'
    - 'tooling/danger/stable_branch.rb'
    - 'tooling/danger/suggestor.rb'
    - 'tooling/lib/tooling/helm3_client.rb'
    - 'tooling/lib/tooling/kubernetes_client.rb'
    - 'tooling/quality/test_level.rb'
    - 'tooling/rspec_flaky/listener.rb'
